CPU 286
BITS 16
ORG -12
    db 'DRV>'   ; It's a driver
    db 0        ; Flags
    db 6        ; Type (Display-driver)
    dw 0        ; Numload (entire file)
    dd 0        ; Reported length (0)

    push cs
    pop ds
    cmp ax, 0
    jz doinit
    cmp ax, 4
    jz uninit
    cmp ax, 0600h
    jz setmode
    cmp ax, 0601h
    jz setpixel
    cmp ax, 0602h
    jz getpixel
    mov ax, 0xDEAD
    retf

doinit:
    xor ax, ax
    mov bx, drvnam
    retf

uninit:
    mov ax, 3   ; Make sure we're in textmode
    int 10h
    retf

setmode:
    mov dl, dh
    xor dh, dh  ; Ignore refresh-rate
    mov si, modedata
    trynextmode:
    cmp [si+2], bx
    jnz notit
    cmp [si+4], cx
    jnz notit
    cmp [si+6], dx
    jnz notit

    mov ax, [si]
    int 10h
    xor ax, ax
    retf

    notit:
    add si, 8
    cmp WORD [si], 0FFFFh
    jnz trynextmode

    mov ax, 0xDEAD
    retf

setpixel:
    mov ax, si
    mov ah, 0ch
    mov dx, cx
    mov cx, bx
    xor bh, bh
    int 10h
    retf

getpixel:
    mov ah, 0dh
    mov dx, cx
    mov cx, bx
    xor bh, bh
    int 10h
    xor ah, ah
    mov si, ax
    retf

drvnam: db 'biosdisplay',0
modedata:
    dw 12h,640,480,4
    dw 13h,320,200,8
    dw 0FFFFh
