CPU 286
BITS 16
ORG -12
    db 'DRV>'   ; It's a driver
    db 0        ; Flags
    db 10       ; Type (Keyboard-driver)
    dw 0        ; Numload (entire file)
    dd 0        ; Reported length (0)

    push cs
    pop ds
    cmp ax, 0
    jz initdrv
    cmp ax, 0700h
    jz initkeyb
    cmp ax, 4h
    jz deinit

    mov ax, 0xDEAD
    retf

initdrv:
    xor ax, ax      ; There is always a keyboard
    retf

initkeyb:
    mov ah, [isinited]
    cmp ah, 0
    jnz retfjmp

    mov [callback], si
    mov [callback+2], es

    mov ax, 3509h
    int 21h
    mov ax, es
    mov [int9ret+1], bx
    mov [int9ret+3], ax

    mov ax, 2509h
    mov dx, newint9
    int 21h
    mov BYTE [isinited], 1

retfjmp:
    retf

deinit:
    mov ah, [isinited]
    cmp ah, 0
    jz retfjmp
    mov BYTE [isinited], 0

    mov dx, [int9ret+1]
    mov ax, [int9ret+3]
    mov ds, ax
    mov ax, 2509h
    int 21h
    retf

newint9:
    push ax
    push bx
    push cx
    push dx
    push si
    push di
    push es
    push ds
    push bp
    mov ax, cs
    mov ds, ax

 ; 1st: Send scancode to kernel
    in al, 60h
    mov bl, al
    xor bh,bh
    and bl,07fh
    test al, 080h
    jnz relecode
    mov ax, 1       ; KB_DOWN
    jmp makecode
relecode:
    mov ax, 2       ; KB_UP
makecode:
    call far [callback]

 ; 2nd: Let DOS/BIOS handle the keystroke
    pushf
int9ret: call 0FFFFh:0000h

 ; 3rd: Have a look at the keyboard buffer and load the ASCII-Code

    mov ah, 1
    int 16h
    jz noascii

    push cs
    pop ds
    xor ah,ah
    int 16h
    cmp al, 0
    jz excode

    mov bl, al
    mov bh, 0
    mov ax, 3   ; KB_ASCII
    call far [callback]
    jmp noascii

    excode:
    mov bl, ah
    mov bh, 0FFh
    mov ax, 3   ; KB_ASCII
    call far [callback]
    
    noascii:
    pop bp
    pop ds
    pop es
    pop di
    pop si
    pop dx
    pop cx
    pop bx
    pop ax
    iret

callback    dw 0,0
drvnam:     db 'bioskeyb',0
isinited:   db 0
