CPU 286
BITS 16
ORG -12
    db 'DRV>'   ; It's a driver
    db 0        ; Flags
    db 7        ; Type (Mouse-driver)
    dw 0        ; Numload (entire file)
    dd 0        ; Reported length (0)

    push cs
    pop ds
    cmp ax, 0702h
    jz movemouse
    cmp ax, 0
    jz initdrv
    cmp ax, 0700h
    jz initmouse
    cmp ax, 4h
    jz deinit

    mov ax, 0xDEAD
    retf

initdrv:
    xor ax, ax      ; Function 0: Check for a mouse
    int 33h
    cmp ax, 0
    jz nomouse
    mov bx, drvnam
    xor ax, ax
    retf
nomouse:
    mov ax, -42     ; Error-code
    retf

initmouse:
    mov [callback], si
    mov [callback+2], es

    mov ax, 0ch     ; Set user function
;    mov cx, 007fh   ; Notify on all events
    mov cx, 0FFFFh
    mov dx, mousecall
    push cs
    pop es
    int 33h
    retf

movemouse:
    mov ax, 4       ; Set mouse.pos (CX/DX is OK)
    int 33h
    retf

deinit:
    mov ax, 0ch     ; Set user function
    mov cx, 0000h   ; Never notify
    int 33h
    retf

mousecall:
    push ax
    push bx
    push cx
    push dx
    push si
    push di
    push es
    push ds
    push bp

    mov ax, cs
    mov ds, ax
    xor ax, ax      ; We don't have a wheel (not sup. yet)
    call far [callback]
    pop bp
    pop ds
    pop es
    pop di
    pop si
    pop dx
    pop cx
    pop bx
    pop ax
    retf

callback    dw 0,0
drvnam:     db 'dosmouse',0
