#pragma pack()

unsigned tmpcount=0;

// Counts the slashs in a pathname
int countslash(char *path)
    {
    int i=0;
    while(*path != '\0')
        if(*(path++) == '/')
            i++;
    return i;
    }

// Compares the beginning of longp with shortp
int matchfirst(char *longp, char *shortp)
    {
    while(*shortp != '\0')
        if(*(longp++) != *(shortp++))
            return 0;
    return 1;
    }

// This cuts the last part in a path away
void cutlastaway(char *p)
    {
    p = p + strlen(p) - 2;
    while(*p != '/') p--;
    *p = '\0';
    }

char *splitpath(char **ptr)
    {
    char *p;
    unsigned long i;
    if(*ptr == NULL) return NULL;
    if((p = strchr(*ptr,'/')) == NULL)
        {
        p = *ptr;
        *ptr = NULL;
        return mem_strnew(p,0);
        }
    i = ((unsigned long) p) - ((unsigned long) *ptr);
    p = mem_malloc(i+1,0);
    strncpy(p,*ptr,i);
    *(p + i) = 0;
    *ptr = *ptr + i + 1;
    return p;
    }

char *makeabs(char *relp, char *curdir)
    {
    char *p;
    char *q, *qq;
    if(relp[0] == '/') return mem_strnew(relp,0);

    p = mem_malloc(strlen(relp) + strlen(curdir) + 2,0);  // make sure there's enough mem
    strcpy(p,curdir);
    q = p + strlen(p) - 1;
    if(*q == '/') *q = '\0';

    q = relp;
    while(1)
        {
        if((qq = splitpath(&q)) == NULL) break;

        if(!strcmp(qq,"."))
            {}
        else if(!strcmp(qq,".."))
            cutlastaway(p);
        else
            {
            strcat(p,"/");
            strcat(p,qq);
            }
//        printf("memfreemakeabs");
        mem_free(qq);
        }
    return p;
    }

/* char *trailslash(char *a)
    {
    if(*(a + strlen(a) - 1) != '/')
        {
        char *mfree;
        mfree = mem_malloc(strlen(a) + 2,0);
        strcpy(mfree,a);
        strcat(mfree,"/");
        mem_free(a);
        a = mfree;
        }
    return a;
    } */

char *slashtobs(char *dev, char *a)
    {
    char *b=mem_malloc(strlen(a)+strlen(dev)+1,0),*c;
    strcpy(b, dev);
    strcat(b, a);

    c=b-1;
    while(*(++c) != '\0')
        if(*c == '/') *c = '\\';
    return b;
    }

int fsmount(char *path, char *param, int driver)
    {
    int i;
    for(i=0;i<MOUNT_MAX;i++)
        if(mdevs[i].pathname == NULL)
            goto fndit;
    return ERR_TOOMANYMOUNTEDFS;
    fndit:;
    if(driver == 128)
        {
        int fp;
        char *sdff=slashtobs(param,"nul");
        fp = ffopen(sdff,0);
        if(fp == 0)
            {
//            printf("memfreefsmount");
            mem_free(sdff);
            return ERR_MOUNTPARAMINVALID;
            }
        ffclose(fp);
//        printf("memfreesddf");
        mem_free(sdff);

        mdevs[i].pathname = mem_malloc(strlen(path)+strlen(param)+2,0);
        mdevs[i].params = mdevs[i].pathname + strlen(path) + 1;
        strcpy(mdevs[i].pathname, path);
        strcpy(mdevs[i].params, param);
        mdevs[i].driverid = 128;
        return 0;
        }
    else if(driver == 131)
        {
        mdevs[i].pathname = mem_strnew(path,0);
        mdevs[i].params = NULL;
        mdevs[i].driverid = 131;
        return 0;
        }
    else
        return ERR_INVALIDDRIVER;
    return ERR_UNKNOWN;
    }

int fsopen2(char *abspath, int whobel, int cancreate)
    {
    int i,j=-1,k,l=0;
    char *orig=abspath;
    for(i=0;mdevs[i].pathname != NULL;i++)
        if(matchfirst(abspath,mdevs[i].pathname))
            if((k = countslash(mdevs[i].pathname)) > l)
                l = k, j = i;
    // We now have the mdevs-id in j
    if(j == -1)
        return ERR_ROOTNOTMOUNT;
    abspath = abspath + strlen(mdevs[j].pathname);
    i = mdevs[j].driverid;
    // Now is the driver in i
    for(k=0;k<FILE_MAX;k++)
        if(fhandles[k].filename == NULL)
            goto fhndfnd;
    return ERR_TOOMANYOPENFILES;
    fhndfnd:
    // And a free handle in k

    if(i == 128)
        {
        int fp;
        char *a=slashtobs(mdevs[j].params,abspath);
        if((fp = ffopen(a,cancreate)) < 0)
            return fp;

        fhandles[k].len = ffsize(fp);
        fhandles[k].mtabent = j;
        fhandles[k].pos = 0;
        fhandles[k].filename = mem_strnew(orig,0);
        fhandles[k].owner = whobel;
        *((UINT *) fhandles[k].drvres) = fp;
//        printf("memfreeopen128");
        mem_free(a);
        return k;
        }
    else if(i == 131)
        {
        for(l=0;l<DRIVER_MAX;l++)
            if(drvlist[l].used)
                if(!strcmp(drvlist[l].dname,abspath))
                    {
                    fhandles[k].mtabent = j;
                    fhandles[k].pos = 0;
                    fhandles[k].filename = mem_strnew(orig,0);
                    fhandles[k].len = drvlist[l].length;
                    fhandles[k].drvres[0] = (unsigned) l;
                    fhandles[k].owner = whobel;
                    if(l == 134 || l == 135)    // FIFO?
                        {
                        fhandles[k].drvres[1] = 0;  // read ptr
                        fhandles[k].drvres[2] = 0;  // write ptr
                        fhandles[k].drvres[3] = 63;    // size-1
                        fhandles[k].drvres[4] = 0;  // status (0=empty/normal,1=full)
                        ((unsigned *) fhandles[k].drvres)[4] = mem_salloc(64,whobel);
                        }
                    return k;
                    }
        return ERR_FILENOTFOUND;
        }
    return ERR_INVALIDDRIVER;
    }

// ret.val = bytes read (<0=file/driver/handle error - 0=nothing read)
int fsread(int handle, unsigned howmuch, char *buffer)
    {
    unsigned int i,j=fhandles[handle].mtabent;
    unsigned int k=mdevs[j].driverid;
    char *p,*q;
    if(!fhandles[handle].filename) return ERR_INVALIDHANDLE;

    if(k == 128)
        {
        i = ffread(*((UINT *) fhandles[handle].drvres),howmuch,buffer);
        fhandles[handle].pos = fftell(*((UINT *) fhandles[handle].drvres));
//        i = fread(buffer,1,howmuch,*((FILE **) (fhandles[handle].drvres)));
//        fhandles[handle].pos = ftell(*((FILE **) (fhandles[handle].drvres)));
        return i;
        }
    else if(k == 131)
        {
        i = fhandles[handle].drvres[0];
        if(i == 129)
            return 0;       // reading tty in a gui? nope.
        else if(i == 130)
            {
            for(i=0;i<howmuch;i++)
                buffer[i] = 0;
            return howmuch;
            }
        else if(i == 134 || i == 135)
            {
            p = MK_FP(((unsigned *) fhandles[handle].drvres)[4],0);
            for(i=0;i<howmuch;i++)
                {
                retestread:;
                if(fhandles[handle].drvres[1] == fhandles[handle].drvres[2])
                    if(fhandles[handle].drvres[4])
                        fhandles[handle].drvres[4] = 0;
                    else
                        {
                        waitmessageorhandle(curtask,handle);
                        j = peekmessage(curtask);
                        if(j > 0)
                            dispatchmessage(tasks[curtask].msg[j].sender,curtask,tasks[curtask].msg[j].msgid,tasks[curtask].msg[j].a,tasks[curtask].msg[j].b,tasks[curtask].msg[j].c);
                        goto retestread;
                        }
                buffer[i] = p[fhandles[handle].drvres[1]];
                if(fhandles[handle].drvres[1]++ == fhandles[handle].drvres[3])
                    fhandles[handle].drvres[1] = 0;
                }
            return howmuch;
            }
        else
            {
            p = (void *) drvlist[i].drvcall;
            j = FP_SEG(buffer); k = FP_OFF(buffer);
            if(p)
              _asm
                {
                mov ax, j
                mov es, ax
                mov di, k
                mov ax, 0103h
                mov cx, howmuch
                mov dx, handle
                mov i, ax
                }
            else i = 0xDEAD;

            if(i == 0xDEAD) return ERR_INVALIDREQUEST;
            return i;
            }
        }
    return ERR_INVALIDDRIVER;
    }
 
// ret.val = bytes written (<0=file/driver/handle error - 0=nothing written)
int fswrite(int handle, unsigned howmuch, char *buffer)
    {
    unsigned int i,j=fhandles[handle].mtabent;
    unsigned int k=mdevs[j].driverid;
    char *p;
    if(!fhandles[handle].filename) return ERR_INVALIDHANDLE;
    if(k == 128)
        {
        i = ffwrite(*((UINT *) fhandles[handle].drvres),howmuch,buffer);
        fhandles[handle].pos = fftell(*((UINT *) fhandles[handle].drvres));
//        i = fwrite(buffer,1,howmuch,*((FILE **) &(fhandles[handle].drvres)));
//        fhandles[handle].pos = ftell(*((FILE **) &(fhandles[handle].drvres)));
        return i;
        }
    else if(k == 131)
        {
        i = fhandles[handle].drvres[0];
        if(i == 129)
            {
            unsigned char x;
            for(i=0;i<howmuch;i++)
                {
                x = buffer[i];
                if(fhandles[handle].drvres[8])
                    _asm
                        {
                        mov ah, 9
                        xor bh, bh
                        mov cx, 1
                        mov al, x
                        mov bl, 7
                        int 10h
                        mov ah, 03h
                        xor bh,bh
                        int 10h
                        xor bh,bh
                        inc dl
                        cmp dl, 80
                        jnz rowcolok
                        xor dl,dl
                        inc dh
                        rowcolok:
                        mov ah, 02h
                        int 10h
                        }
                    else
                        putch(x);
                }
            return howmuch;
            }
        else if(i == 130)
            return howmuch; // NULL-Device does really nothing
        else if(i == 134)
            {
            p = MK_FP(((unsigned *) fhandles[handle].drvres)[4],0);
            for(i=0;i<howmuch;i++)
                {
                if(fhandles[handle].drvres[4])
                    {
                    printf("overflow");
                    return i;
                    }
                p[fhandles[handle].drvres[2]] = buffer[i];
                if(fhandles[handle].drvres[2]++ == fhandles[handle].drvres[3])
                    fhandles[handle].drvres[2] = 0;
                if(fhandles[handle].drvres[1] == fhandles[handle].drvres[2])
                    fhandles[handle].drvres[4] = 1;
                }
//            printf("[[%s]]\n",p);
            return howmuch;
            }
        else
            {
            p = (void *) drvlist[i].drvcall;
            j = FP_SEG(buffer); k = FP_OFF(buffer);
            if(p)
              _asm
                {
                mov ax, j
                mov es, ax
                mov di, k
                mov ax, 0104h
                mov cx, howmuch
                mov dx, handle
                call p
                mov i, ax
                }
            else i = 0xDEAD;
            if(i == 0xDEAD) return ERR_INVALIDREQUEST;
            return i;
            }
        }
    return ERR_INVALIDDRIVER;
    }

int fsseek(int handle, long where, int from)
    {
    unsigned int i,j=fhandles[handle].mtabent;
    unsigned int k=mdevs[j].driverid;
    long x;
         if(from == SEEK_SET) x = where;
    else if(from == SEEK_CUR) x = fhandles[handle].pos+where;
    else if(from == SEEK_END) x = fhandles[handle].len+where;
    if(x < 0) x = 0;
    if(x > (fhandles[handle].len-1)) x = fhandles[handle].len - 1;
    if(x == fhandles[handle].pos) return 0;

    if(k == 128)
        {
        fhandles[handle].pos = ffseek(*((UINT *) fhandles[handle].drvres),x,SEEK_SET);
        }
    }
    
char fsgetc(int handle)
    {
    char r;
    int i;
    if((i = fsread(handle,1,&r)) > 0)
        return r;
    else
        return 0;
    }

void fsgets(int handle, char *buf, UINT buflen)
    {
    UINT bufidx=0; UCHR x;
    while(1)
        {
        x = fsgetc(handle);
        if(x == 13) {}
        else if(x == 10)
            {
            buf[bufidx] = 0;
            return;
            }
        else if(x == 8)
            {
            if(bufidx-- == 0) bufidx = 0;
            }
        else if(x == 0)
            {
            buf[bufidx] = 0;
            return;
            }
        else
            buf[bufidx++] = x;
        }
    }

UINT fsgetw(int handle)
    {
    UINT r;
    int i;
    if((i = fsread(handle,2,(void *) &r)) > 0)
        return r;
    else
        return 0;
    }

ULNG fsgetdw(int handle)
    {
    ULNG r;
    int i;
    if((i = fsread(handle,4,(void *) &r)) > 0)
        return r;
    else
        return 0;
    }

int fsputs(int handle, char *str)
    {
    char c[2]={ 13, 10 };
    if(*str != '\0') fswrite(handle,strlen(str),str);
    fswrite(handle,2,c);
    }

// Opens a file like fsopen, but with relative name support
#define fsopenrel(path,curdir,whobel) (fsopenrel2((path),(curdir),(whobel),0))
int fsopenrel2(char *path, char *curdir, int whobel, int cancreate)
    {
    char *a=makeabs(path,curdir);
    int i=fsopen2(a,whobel,cancreate);
    printf("opening absolute:%s\n",a);
    printf("memfreeopenrel");
    mem_free(a);
    return i;
    }

void fsclose(int handle)
    {
    int j=fhandles[handle].mtabent;
    int k=mdevs[j].driverid;

    if(k == 128)
        ffclose(*((UINT *) fhandles[handle].drvres));
    else if(k == 131)
        {
        if(fhandles[handle].drvres[0] == 134)
            mem_free(MK_FP(((unsigned *) fhandles[handle].drvres)[4],0));
        }
    else
        return; // ERR_INVALIDDRIVER;

    mem_free(fhandles[handle].filename);
    fhandles[handle].filename = NULL;
    }

void fs_cleanup(int tid)
    {
    int i;
    for(i=0;i<FILE_MAX;i++)
        if(fhandles[i].owner == tid)
            fsclose(i);
    }

void getstoend(int hndl, char *buf)
    {
    *buf = '\0';
    while(1)
        {
        fsgets(hndl,buf,1024);
        if(!strcmp(buf,"-END-"))
            {
            *buf = '\0';
            return;
            }
        buf += strlen(buf);
        if(fhandles[hndl].len == fhandles[hndl].pos)
            return;
        *(buf++) = '\n';
        }
    }

createtmp(int owner)
    {
    int hndl;
    char tmpnam[64];
    sprintf(tmpnam,"%s%u",tmpdir,tmpcount++);

    if((hndl = fsopen2(tmpnam,owner,1)) > 0)
        fhandles[hndl].tmpfile = 1;
    return hndl;
    }

copystuff(int src, int dest, int owner)
    {
    char *buffer=mem_malloc(8192,owner);
    if(buffer == NULL)
        return ERR_OUTOFMEMORY;
    while(fswrite(dest,fsread(src,8192,buffer),buffer) == 8192) {}
    printf("memfreecopystuff");
    mem_free(buffer);
    return 0;
    }
             
