// GUI interface - using "controls.h" elements

#define CT_BUTTON 1
#define CT_RADIO 2
#define CT_CHECKBOX 3
#define CT_LABEL 4
#define CT_TEXTBOX 5
#define CT_SIMPLEBUTTON 6
#define CT_RECT 7
#define CT_RECTF 8
#define CT_DDB 9
#define CT_SPRITE 10
#define CT_0815 11
#define CT_SCROLLBAR 12
#define CT_LISTBOX 13
#define CT_COMBOBOX 14
#define CT_DIB 15

canhavefocus(int typ) { return ((typ < 7) && (typ != CT_LABEL)) || (typ > 11); }

unsigned nextguid=1;
char *curbox = NULL;

draw_ok_msgbox() { wm_drawcompletebutton(0, (curx/2)-(curx/3), (cury/2)-20, (curx/2)+(curx/3), (cury/2)+20, 0, 0, 9, 14, curbox); }

struct guiele
    {
    UCHR typ;
    UINT wnd;       // all
    UINT x1,y1;     // all
    UINT x2,y2;     // button,rect,rectf,scrollbar,listbox,combobox:only x2
    UCHR checked;   // radio,checkbox,scrollbar:ishoriz
    char *text;     // button,label,textbox,simplebutton
    UINT fntid;     // button,label,textbox,simplebutton,scrollbar:value,listbox
    UINT fgcol;     // rect,rectf,button,label,textbox,simplebutton,scrollbar:min,listbox
    UINT bgcol;     // button,scrollbar:max,listbox
    void *data;     // ddb,sprite,0815,listbox,combobox
    UCHR lstate;    // internal: button,radio,checkbox,simplebutton
    UINT grp;       // radio,listbox&combobox:itemindex
    UCHR visible;   // all
    UINT id;
    UINT tag1,tag2; // tag
    struct guiele *subitem;   // listbox
    struct guiele *ownedby;   // scrollbar
    struct guiele *next;
    } *guiele;

struct guiele *getactiveguiele(int wnd)
    {
    if(uldat) return uldat->windat[wnd].actctrl; else return NULL;
    }

setactiveguiele(struct guiele *new)
    {
    if(uldat) uldat->windat[new->wnd].actctrl = new;
    }

guiele_has_text(int typ)
    {
    return (typ == CT_BUTTON) || (typ == CT_LABEL) || (typ == CT_TEXTBOX) || (typ == CT_SIMPLEBUTTON);
    }

guiele_has_data(int typ)
    {
    return (typ == CT_DDB) || (typ == CT_SPRITE) || (typ == CT_0815);
    }

guiele_datasize(int typ, void *data)
    {
    switch(typ)
        {
        case CT_DDB: return ddbsize(data);
        case CT_SPRITE: return strlen(data)+1;
        case CT_0815: return ddbwidth(data)*ddbheight(data)*2+4;
        }        
    return 0;
    }

paintinnerlistbox(struct guiele *p, int reallypaint, int iidx);   // See descr. below at the implementation


print_ele(struct guiele *p)
    {
    if(!p) return 1;
    printf("ele is a %i\n",p->typ);
    if(p->ownedby)
        {
        putch('O');
        putch('w');
        putch('n');
        putch('e');
        putch('d');
        putch('b');
        putch('y');
        putch(':');
        print_ele(p->ownedby);
        }
/*    if(p->subitem)
        {
        putch('S');
        putch('u');
        putch('b');
        putch('i');
        putch('t');
        putch('e');
        putch('m');
        putch(':');
        print_ele(p->subitem);
        }     */
    }

gui_correct_size(struct guiele *new)
    {
    int i;
    switch(new->typ)
        {
        case CT_SIMPLEBUTTON:
            new->bgcol = 7,
            new->y2 = new->y1 + textheight(new->fntid,new->text) + 5,
            new->x2 = new->x1 + textwidth(new->fntid,new->text) + 5;
            break;
        case CT_RADIO:
        case CT_CHECKBOX:
            new->x2 = new->x1 + 13,
            new->y2 = new->y1 + 13;
            break;
        case CT_LABEL:
            new->y2 = new->y1 + textheight(new->fntid,new->text),
            new->x2 = new->x1 + textwidth(new->fntid,new->text);
            break;
        case CT_SPRITE:
            sprite_size(new->data,&(new->x2),&(new->y2));
            addme:
            new->x2 += new->x1,
            new->y2 += new->y1;
            break;
        case CT_DDB:
            new->x2 = new->x1 + ddbwidth(new->data),
            new->y2 = new->y1 + ddbheight(new->data);
            break;
        case CT_DIB:
            dib_geometry(new->fntid,(unsigned *) &(new->x2),(unsigned *) &(new->y2));
            goto addme;
        case CT_LISTBOX:
            new->subitem->bgcol = ((i = ((strlist *) new->data)->count - paintinnerlistbox(new->subitem,0,-1)) < 0) ? (i=0) : i;
            new->subitem->visible = !!i;
            if(i)
                {
                new->subitem->x1 = new->x2+1;
                new->subitem->y1 = new->y1;
                new->subitem->x2 = new->subitem->x1 + 10;
                new->subitem->y2 = new->y2;
                new->subitem->fgcol = 0;
                }
            break;
        case CT_COMBOBOX:
            new->y2 = new->y1 + textheight(new->fntid,allthechars) + 6;
            new->subitem->data = new->data;
            new->subitem->grp = new->grp;
            break;
        }
    }

struct guiele *gui_findobj(int id)
    {
    struct guiele *p=guiele;
    while(p)
        {
        if(p->id == id)
            return p;
        p = p->next;
        }
    return NULL;
    }

gui_create(struct guiele *newobj)
    {
    struct guiele *p,*new=mem_dupobj(newobj,sizeof(struct guiele),0);
    if(!getactiveguiele(new->wnd)) setactiveguiele(new);
    if(new == NULL)
        return ERR_OUTOFMEMORY;
    new->lstate = 0;
    if(guiele == NULL)
        guiele = new;
    else
        {
        p = guiele;
        while(p->next) p=p->next;
        p->next = new;
        }
    new->next = NULL;
    new->id = nextguid++;

    if(guiele_has_text(new->typ)) new->text = mem_strnew(new->text,getwndowner(new->wnd));
    if(guiele_has_data(new->typ)) new->data = mem_dupobj(new->data,guiele_datasize(new->typ,new->data),getwndowner(new->wnd));
    if(!(newobj->data))
      {
      new->checked = (new->typ == CT_LISTBOX);  // Can't include this in the "if" - compiler gives warning
      if(new->checked)
        {
        new->data = mem_malloc(sizeof(strlist),getwndowner(new->wnd));
        strl_initnew(new->data,16,getwndowner(newobj->wnd));
        }
      }
    if(new->typ == CT_LISTBOX)
        {
        newobj->typ = CT_SCROLLBAR;
        newobj->checked = 0;
        newobj->fntid = 0;
        newobj->fgcol = 0;
        newobj->bgcol = ((strlist *) new)->count - 1;
        newobj->ownedby = new;
//        newobj->subitem = NULL;
        newobj->visible = 1;
        new->subitem = gui_findobj(gui_create(newobj));
        }
    else if(new->typ == CT_COMBOBOX)
        {
        newobj->typ = CT_LISTBOX;
        newobj->visible = 0;
        newobj->ownedby = new;
        newobj->subitem = NULL;
        p = gui_findobj(gui_create(newobj));    // listbox needs to be on top
        p->next = guiele;
        p->ownedby = new;
        guiele = p;
        new->subitem = p;
        new->next = NULL;
        }
    gui_correct_size(new);
    return new->id;
    }

void gui_delete(UINT id)
    {
    struct guiele *op,*p=guiele;
    if(p->id == id)
        {
        guiele = p->next;
        if(guiele_has_text(p->typ)) { printf("guideletefreetext"); mem_free(p->text); }
        if(guiele_has_data(p->typ)) { printf("guideletefreedata"); mem_free(p->data); }
        if(p->typ == CT_LISTBOX && p->checked) strl_free(p->data);
        printf("guielememfree");
        mem_free((char *) p);
        }
    else
        while(p->next)
            {
            if(p->next->id == id)
                {
                op = p->next->next;
                if(guiele_has_text(p->next->typ)) { printf("guideletefreetext2"); mem_free(p->next->text); }
                if(guiele_has_data(p->next->typ)) { printf("guideletefreedata2"); mem_free(p->next->data); }
                if(p->next->typ == CT_LISTBOX && p->next->checked) strl_free(p->next->data);
                
                printf("guielememfree2");
                mem_free((char *) p->next);
                p->next = op;
                }
            p = p->next;
            }
    }

gui_cleanup(UINT pid)
    {
    int i;
    struct guiele *p=guiele;
    while(p)
        {
        if(getwndowner(p->wnd) == pid)
            {
            gui_delete(p->id);
            p = guiele;
            }
        else
            p = p->next;
        }
    }

    // function returns number of items displayable at once
    // set reallypaint to 0 if you only want to get this value
paintinnerlistbox(struct guiele *p, int reallypaint, int iidx)
    {
    int clx1,cly1,clx2,cly2;    // Client area
    int num,ih,ti,i,j;
    if(!p->data) return 0;
    clx1 = p->x1+2, cly1 = p->y1+2, clx2 = p->x2 - 2, cly2 = p->y2 - 2;
    ih = textheight(p->fntid,strl_getitem((strlist *) p->data,0));
    num = (cly2-cly1-1) / ih;
    if(reallypaint)
        {
        ti = p->subitem->fntid;     // scrollbar pos
        if(!(iidx+1)) wm_rectf(p->wnd,clx1,cly1,clx2,cly2,p->bgcol);
        for(i=0,j=ti;i<num && j<((strlist *) p->data)->count;i++,j++)
          if((!(iidx+1)) || (iidx == j))
            if(j==p->grp)
                {
                wm_rectf(p->wnd, clx1 ,cly1+ih*i+1, clx2, cly1+ih*(i+1), p->fgcol);
                wm_textout(p->wnd,clx1+1,cly1 + ih*i + 1,p->bgcol,0xFFF,p->fntid,strl_getitem(((strlist *) p->data),j));
                }
            else
                {
                if(iidx == j)
                    wm_rectf(p->wnd, clx1 ,cly1+ih*i+1, clx2, cly1+ih*(i+1), p->bgcol);
                wm_textout(p->wnd,clx1+1,cly1 + ih*i + 1,p->fgcol,0xFFF,p->fntid,strl_getitem(((strlist *) p->data),j));
                }
        }
    return num;
    }

drawscrollbutton(struct guiele *p, int col)
    {
    int x1,y1,x2,y2;
    unsigned long d,e;
    if(p->checked)
        {   // horizontal
        y1 = p->y1 + 1;
        y2 = p->y2 - 1;
        d = p->x2-p->x1-29;
        if(p->bgcol - p->fgcol)
            e = (p->fntid - p->fgcol) * d / (p->bgcol-p->fgcol);
        else
            e = 0;
        x1 = p->x1+10+e;
        x2 = x1 + 12;
        if(x2 > (p->x2-10)) x2 = p->x2 - 10;
        }
    else
        {   // vertical
        x1 = p->x1 + 1;
        x2 = p->x2 - 1;
        d = p->y2-p->y1-29;
        if(p->bgcol - p->fgcol)
            e = (p->fntid - p->fgcol) * d / (p->bgcol-p->fgcol);
        else
            e = 0;
        y1 = p->y1+10+e;
        y2 = y1 + 12;
        if(y2 > (p->y2-10)) y2 = p->y2 - 10;
        }
    wm_rectf(p->wnd,x1,y1,x2,y2,col);
    }

gui_repaintele(struct guiele *p, UINT id)   // Use p or id, whatever u like
    {
    if(p) goto alrgp;
    while(p)
        if(p->id == id)
            {
            alrgp:;
            if(!isvisible(p)) return 3;
            switch(p->typ)
                {
                case CT_SIMPLEBUTTON:
                case CT_BUTTON:     wm_drawcompletebutton(p->wnd,p->x1,p->y1,p->x2,p->y2,p->lstate == 1,p->fntid,p->fgcol,p->bgcol,p->text);
                                    break;
                case CT_RADIO:      wm_drawoptbtn(p->wnd,p->x1,p->y1,p->checked,p->lstate == 1);
                                    break;
                case CT_CHECKBOX:   wm_drawcheckbox(p->wnd,p->x1,p->y1,p->checked,p->lstate);
                                    break;
                case CT_LABEL:      wm_outtext(p->wnd,p->x1,p->y1,p->fgcol,p->bgcol,p->fntid,p->text);
                                    break;
                case CT_TEXTBOX:    wm_drawbuttondown(p->wnd,p->x1,p->y1,p->x2,p->y2,p->bgcol);
                                    wm_outtext(p->wnd,p->x1+3,p->y1+3,p->fgcol,p->bgcol,p->fntid,p->text);
                                    break;
                case CT_RECT:       wm_rect(p->wnd,p->x1,p->y1,p->x2,p->y2,p->fgcol);
                                    break;
                case CT_RECTF:      wm_rectf(p->wnd,p->x1,p->y1,p->x2,p->y2,p->fgcol);
                                    break;
                case CT_DDB:        wm_drawddb(p->wnd,p->x1,p->y1,p->data);
                                    break;
                case CT_DIB:        wm_dib_draw_dib(p->wnd,p->x1,p->y1,p->fntid);
                                    break;
                case CT_0815:       wm_set0815(p->wnd,p->x1,p->y1,p->data);
                                    break;
                case CT_SPRITE:     wm_drawsprite(p->wnd,p->x1,p->y1,p->data);
                                    break;
                case CT_SCROLLBAR:  wm_drawscrollbase(p->wnd,p->x1,p->y1,p->x2,p->y2,p->checked);
                                    drawscrollbutton(p,9);
                                    break;
                case CT_LISTBOX:    wm_drawbuttondown(p->wnd,p->x1,p->y1,p->x2,p->y2,15);
                                    paintinnerlistbox(p,1,-1);
                                    gui_repaintele(p->subitem,0);
                                    break;
                case CT_COMBOBOX:   wm_drawbuttondown(p->wnd,p->x1,p->y1,p->x2-11,p->y2,p->bgcol);
                                    wm_drawbutton(p->wnd,p->x2-13,p->y1,p->x2,p->y2,7);
                                    wm_drawsprite(p->wnd,p->x2-10,(p->y2+p->y1)/2 - 2,arrdown);
                                    if(p->text)
                                        wm_textout(p->wnd,p->x1+4,p->y1+4,p->fgcol,0xFFF,p->fntid,p->text);
                                    gui_repaintele(p->subitem,0);
                                    break;
                }
            return 0;
            }
        else p = p->next;
    return ERR_INVALIDGUIELE;
    }

void gui_repaintwnd(UINT wnd)
    {
    struct guiele *p=guiele;
    while(p)
        {
        if( ((!p->ownedby) || (p->ownedby->typ != CT_COMBOBOX)) && p->wnd == wnd && (!p->ownedby))
            gui_repaintele(p,0);
        p = p->next;
        }
    p=guiele;
    while(p)
        {
        if(p->ownedby && (p->ownedby->typ == CT_COMBOBOX))
            gui_repaintele(p,0);
        p = p->next;
        }
    }

isvisible(struct guiele *p)
    {
    if(!p) return 0;
    while(p)
        {
        if(!p->visible) return 0;
        p = p->ownedby;
        }
    return 1;
    }
struct guiele* gui_getelementat(UINT wnd, UINT x, UINT y)
    {
    struct guiele *p=guiele;
    while(p)
        {
        if(isvisible(p) && (p->wnd == wnd) && (x >= p->x1) && (x <= p->x2) && (y >= p->y1) && (y <= p->y2))
            return p;
        p = p->next;
        }
    return NULL;
    }
#define gui_sendmessage(wnd,msg,b,c) sendmessage(0,getwndowner(wnd),msg,wnd,b,c)

lscroll(struct guiele *p, int wndy)
    {
    int j;
    j = (wndy - p->y1 - 5) * (p->bgcol - p->fgcol) / (p->y2 - p->y1 - 20) + p->fgcol;
    if(j == p->fntid) return;
    drawscrollbutton(p,7);
    p->fntid = j;
    gui_sendmessage(p->wnd,MSG_SCROLL,p->id,p->fntid);
    if(p->ownedby->typ == CT_LISTBOX)
        paintinnerlistbox(p->ownedby,1,-1);
    drawscrollbutton(p,9);
    }

gui_wmintercept(UINT msg,UINT wnd,UINT b, UINT c)
    {
    struct guiele *p,*q;
    int clked,reled,olst,i,j;
    static wndx,wndy;
    if(msg == MSG_PAINT)
        {
        if(uldat->windat[wnd].flgs & WF_FILL)
            wm_fillclient(wnd,uldat->windat[wnd].fill);
        gui_repaintwnd(wnd);
        if(curbox)
            draw_ok_msgbox();
        }
    else if(msg == MSG_KEYDOWN)
        {
        p = getactiveguiele(wnd);
        if(b == KBSC_TAB)
            {
            j=0;
            nochmalguiele:
            if(p) p=p->next; else p = guiele;
            while(p)
                {
                if(p->wnd == wnd && canhavefocus(p->typ))
                    {
                    setactiveguiele(p);
                    return 0;
                    }
                p=p->next;
                }
            if(j++ == 0) goto nochmalguiele;
            }
        else if(p)
            {
            switch(p->typ)
                {
                case CT_BUTTON:
                case CT_SIMPLEBUTTON:
                    if(b == KBSC_ENTER)
                        gui_sendmessage(wnd,MSG_CLICK,p->id,p->tag1);
                    else if(b == KBSC_SPACE)
                        if(p->lstate != 1)
                            {
                            p->lstate = 1;
                            gui_repaintele(p,0);
                            }
                    break;
                case CT_CHECKBOX:
                    if(b == KBSC_SPACE)
                        if(p->lstate != 1)
                            {
                            p->lstate = 1;
                            gui_repaintele(p,0);
                            }
                    break;
                case CT_SCROLLBAR:
                    if(b == KBSC_LEFT || b == KBSC_UP)
                        if(p->checked)
                            goto scrollleft;
                        else
                            goto scrollup;
                    else if(b == KBSC_RIGHT || b == KBSC_DOWN)
                        if(p->checked)
                            goto scrollright;
                        else
                            goto scrolldown;
                    break;
                case CT_LISTBOX:
                    if(b == KBSC_LEFT || b == KBSC_UP)
                        {
                        if(p->grp > 0)
                            if(--p->grp < p->subitem->fntid)
                                {
                                p = p->subitem;
                                goto scrollup;
                                }
                            else
                                {
                                paintinnerlistbox(p,1,p->grp+1);
                                paintinnerlistbox(p,1,p->grp);
                                }
                        }
                    else if(b == KBSC_DOWN || b == KBSC_RIGHT)
                        {
                        if(p->grp < (((strlist *) p->data)->count-1))
                            if(++p->grp >= (p->subitem->fntid+paintinnerlistbox(p,0,-1)))
                                {
                                p = p->subitem;
                                goto scrolldown;
                                }
                            else
                                {
                                paintinnerlistbox(p,1,p->grp-1);
                                paintinnerlistbox(p,1,p->grp);
                                }
                        }
                }
            }
        }
    else if(msg == MSG_KEYUP)
        {
        p = getactiveguiele(wnd);
        if(p)
            {
            switch(p->typ)
                {
                case CT_BUTTON:
                case CT_SIMPLEBUTTON:
                    if(b == KBSC_SPACE)
                        {
                        gui_sendmessage(wnd,MSG_CLICK,p->id,p->tag1);
                        p->lstate = 0;
                        gui_repaintele(p,0);
                        }
                    break;
                case CT_CHECKBOX:
                    if(b == KBSC_SPACE)
                        {
                        gui_sendmessage(wnd,MSG_CLICK,p->id,(p->checked = 1-p->checked));
                        p->lstate = 0;
                        gui_repaintele(p,0);
                        }
                    break;
                }
            }
        }
    else if(msg == MSG_MOUSEMOVE)
        {
        p = gui_getelementat(wnd,b,c);
        wndx = b;
        wndy = c;
        if(p)
            {
            if(p->typ == CT_SCROLLBAR && (p->lstate == 1))
                {
                if(!(wndy < p->y1+9) && !(wndy > p->y2-9))
                    lscroll(p,wndy);
                }
            else if(p->lstate == 2)
                {
                p->lstate = 1;
                gui_repaintele(p,0);
                }
            }
        q = guiele;
        while(q)
            {
            if((p != q) && (q->wnd == wnd) && (q->lstate == 1))
                {
                q->lstate = 2;
                if(q->typ != CT_SCROLLBAR) gui_repaintele(q,0);
                }
            q = q->next;
            }
        }
    else if(msg == MSG_MOUSEBUTTON)
        {
//        printf("Got click (WND %i): X=%i, Y=%i, btn=%i, obtn=%i\n",wnd,wndx,wndy,b,c);
        if(!b)
            {
            p = guiele;
            while(p)
                {
                if(p->wnd == wnd && (p->lstate == 2))
                    p->lstate = 0;
                p = p->next;
                }
            }
        q=guiele;
        p = gui_getelementat(wnd,wndx,wndy);
        print_ele(p);
//        if(p == NULL || !((p->ownedby && p->ownedby->typ == CT_COMBOBOX) || (p->ownedby && p->ownedby->ownedby && p->ownedby->ownedby->typ == CT_COMBOBOX)))
//        if(p == NULL || (p->ownedby == NULL) || (p->ownedby->typ != CT_COMBOBOX) )
        if(p == NULL)
          while(q)
            {
            if(q->typ == CT_COMBOBOX && q->subitem->visible)
                {
                q->subitem->visible = 0;
                wm_paint(PF_WNDCONTENT,q->wnd);
                }
            q = q->next;
            }
        if(!p)
            return 1;
        clked = (c) && (!b);
        reled = (!b) && (c);
        olst = p->lstate;
        p->lstate = b ? 1 : 0;
        if(reled && olst == 1 && canhavefocus(p->typ))
            setactiveguiele(p);
        switch(p->typ)
            {
            case CT_SIMPLEBUTTON:
            case CT_BUTTON:
                gui_repaintele(p,0);
                if(reled && olst == 1)
                    gui_sendmessage(wnd,MSG_CLICK,p->id,p->tag1);
                break;
            case CT_CHECKBOX:
                if(reled && olst == 1)
                    gui_sendmessage(wnd,MSG_CLICK,p->id,(p->checked = 1-p->checked));
                gui_repaintele(p,0);
                break;
            case CT_SPRITE:
                if(reled && olst == 1)
                    gui_sendmessage(wnd,MSG_CLICK,p->id,p->tag1);
                break;
            case CT_SCROLLBAR:
                if(reled)
                    {
                    if(p->checked)
                        {   // horizontal
                        if(wndx < p->x1+9) {
                            scrollleft:;
                            if(p->fntid > p->fgcol)
                                {   // scroll left
                                drawscrollbutton(p,7);
                                gui_sendmessage(wnd,MSG_SCROLLBUTTON,p->id,--p->fntid);
                                drawscrollbutton(p,9);
                                } }
                        else if(wndx > p->x2-9) {
                            scrollright:;
                            if(p->fntid < p->bgcol)
                                {   // scroll right
                                drawscrollbutton(p,7);
                                gui_sendmessage(wnd,MSG_SCROLLBUTTON,p->id,++p->fntid);
                                drawscrollbutton(p,9);
                                } }

                        }
                    else
                        {   // vertical
                        if(wndy < p->y1+9) {
                            scrollup:;
                            if(p->fntid > p->fgcol)
                                {   // scroll up
                                drawscrollbutton(p,7);
                                gui_sendmessage(wnd,MSG_SCROLLBUTTON,p->id,--p->fntid);
                                drawscrollbutton(p,9);
                                if(p->ownedby->typ == CT_LISTBOX)
                                    paintinnerlistbox(p->ownedby,1,-1);
                                } }
                        else if(wndy > p->y2-9) {
                            scrolldown:;
                            if(p->fntid < p->bgcol)
                                {   // scroll down
                                drawscrollbutton(p,7);
                                gui_sendmessage(wnd,MSG_SCROLLBUTTON,p->id,++p->fntid);
                                drawscrollbutton(p,9);
                                if(p->ownedby->typ == CT_LISTBOX)
                                    paintinnerlistbox(p->ownedby,1,-1);
                                } }
                        else
                            lscroll(p,wndy);
                        }
                    }
                break;
            case CT_LISTBOX:
                if(reled && olst == 1 && p->data)
                    {
                    i = textheight(p->fntid,strl_getitem((strlist *) p->data,0));
                    i = (wndy - p->y1 - 2) / i;
                    j = p->grp;
                    p->grp = i + p->subitem->fntid;
                    paintinnerlistbox(p,1,j);
                    paintinnerlistbox(p,1,p->grp);
                    gui_sendmessage(wnd,MSG_ITEMSELECT,p->id,i);
                    if(p->ownedby && p->ownedby->typ == CT_COMBOBOX)
                        {
                        gui_sendmessage(wnd,MSG_ITEMSELECT,p->ownedby->id,i);
                        p->ownedby->grp = p->grp;
                        p->ownedby->text = strl_getitem(p->data,p->grp);

                        p->visible = 0;
                        wm_paint(PF_WNDCONTENT,p->wnd);
                        }
                    }
                break;
            case CT_RADIO:
                q = guiele;
                if(reled && olst == 1)
                    {
                    gui_sendmessage(wnd,MSG_CLICK,p->id,p->tag1);
                    while(q)
                        {
                        if(p != q && q->wnd == p->wnd && q->typ == CT_RADIO && q->grp == p->grp)
                            {
                            q->checked = 0;
                            gui_repaintele(q,0);
                            }
                        q = q->next;
                        }
                    p->checked = 1;
                    }
                gui_repaintele(p,0);
                break;
            case CT_COMBOBOX:
                if(reled && olst == 1 && p->data)
                  if(p->subitem->visible)
                    {
//                    p->subitem->visible = 0;
//                    wm_paint(PF_WNDCONTENT,p->wnd);
                    }
                  else
                    {
                        // i stores the number of pixels we would need
                    i = ((strlist *) p->data)->count * textheight(p->fntid,allthechars)+5;
                        // j stores the number of pixels to the end of the window
                    j = cury - tbheight - hbheight - p->y2;
                        // p->y1 stores the number of pixels from the top

                    p->subitem->x1 = p->x1;
                    p->subitem->y1 = p->y2;
                    p->subitem->x2 = p->x2;
                    if(i < j)
                        {   // if the listbox matches in the space below the box
                        p->subitem->y2 = p->y2 + i;
                        }
                    else if(p->y1 > j)
                        {   // doesn't match - is there more space at the top
                        p->subitem->y1 = 20;
                        p->subitem->y2 = p->y1;
                        }
                    else
                        {   // doesn't match - is there more/the same space at the bottom
                        p->subitem->y2 = j - 20;
                        }
//                    printf("listbox on: %i,%i,%i,%i\n",p->subitem->x1,p->subitem->y1,p->subitem->x2,p->subitem->y2);
                    p->subitem->visible = 1;
                    gui_correct_size(p->subitem);
                    setactiveguiele(p->subitem);
                    printf("opening combobox: %.4X(%i),%.4X(%i),%.4X(%i),%.4X(%i),%.4X(%i)",
                        FP_SEG(p),p->typ,
                        FP_SEG(p->subitem),p->subitem->typ,
                        FP_SEG(p->subitem->subitem),p->subitem->subitem->typ,
                        FP_SEG(p->subitem->subitem->ownedby),p->subitem->subitem->ownedby->typ,
                        FP_SEG(p->subitem->subitem->ownedby->ownedby),p->subitem->subitem->ownedby->ownedby->typ);
                    p->subitem->ownedby = p;
                    p->subitem->subitem->ownedby = p->subitem;
                    gui_repaintele(p,0);
                    }
            }
        }
    }

ok_msgbox(char *text)
    {
    int ms = tasks[curtask].msgstat;
    int mb=mousebtn;
    printf("msgbox:%s",text);
    tasks[curtask].msgstat = MS_WANTMOUSEMSG | MS_WANTKEYBMSG;
    curbox = text;
    draw_ok_msgbox();
    nextmsg:
    _asm
        {
        mov ax, 10h         ; getmessage
        int 0F0h
        mov ax, 2000h       ; dispachmessage
        int 0F0h
        cmp dx, MSG_GENERICKEYB
        jz endbox
        cmp dx, MSG_GENERICMOUSE
        jnz nextmsg
        cmp bx, mb
        jz nextmsg
        }
    endbox:
    curbox = NULL;
    tasks[curtask].msgstat = ms;
    wm_paint(PF_WMBARS | PF_WNDCONTENT,fgwin);
    }

