// Memman.h - Memorymanagment functions


// Memory-definations
//      0       = unallocated
//      127     = system allocated
//      128     = kernel allocated
//      1-126   = app.allocated (chained)
//      129-254 = app.allocated (end of chain)
#define mem_alloc mem_malloc
UCHR memtab[32768];

/*
void mem_init(unsigned leave) {}
void mem_free(char *addr) { free(addr); }
// void mem_free(char *addr) {}
char *mem_malloc(long bytes, UINT tid) { return malloc(bytes); }
unsigned mem_salloc(long bytes, UINT tid) { void *p=malloc(bytes); return FP_SEG(p); }
char *mem_strnew(char *orig, UINT tid) { return strdup(orig); }
void mem_cleanup(int tid) { }
unsigned mem_getpara(UCHR ofid) { return 0; }
*/

void mem_init(unsigned leavefree)
    {
    UINT i;
    ULNG siz,j;
    UCHR *p;
    UCHR *first=NULL;
    ULNG fsiz;

    printf("Loading memory-management (leaving %lu Bytes for native OS)\n",(unsigned long) leavefree*32);
    for(i=0;i<32768;i++)
        memtab[i] = 127;
    puts("Taking over");
    siz = 640000;
    _asm
        {
        stackalloc:
        mov cx, 1024
        push ax
        dec cx
        jz stackalloc
        }
    while(siz > 31)
        {
        p = farmalloc(siz);
        if(p == NULL)
            siz = siz - 32;
        else
            {
            if(first == NULL)
                {
                first = p;
                siz = siz - leavefree*32;
                fsiz = siz;
                }
            printf("%li @ SEG %.4X:%.4X\n",siz,FP_SEG(p),FP_OFF(p));
            i = (FP_SEG(p) + 1) / 2;
            j = (FP_SEG(p) + siz / 16) / 2;
            for(;i<j;i++)
                memtab[i] = 0;
            }
        }
        _asm
            {
            stackdealloc:
            mov cx, 1024
            pop ax
            dec cx
            jz stackdealloc
            }
    if(farrealloc(first,fsiz) != first)
        {
        puts("Unknown error calling farealloc()");
        exit(2);
        }

    if((first = malloc(1024)) != NULL)
        free(first);
    else
        puts("WARNING! < 1K free to native memory-management!!\n   Change LEAVEMEM= in the cmdline");

    for(i=0,j=0;i<32768;i++)
        if(memtab[i] == 0) j += 32;
    printf("Got %li Bytes\n",j);
    }

#define mem_malloc(bytes,tid) ((char *) MK_FP(mem_salloc(bytes,tid),0))

unsigned mem_salloc(long bytes, UCHR tid)
    {
    UINT i,j,ms;
    tid = (tid+1) & 0x7F;
    if((ms = (bytes + 31) / 32) == 0) return NULL;
    for(i=0;i<(32768-ms);i++)
        {
        for(j=i;j<(i+ms);j++)
            if(memtab[j] != 0) goto mx;

        for(j=i;j<(i+ms);j++)
            memtab[j] = tid;
        memtab[j-1] = tid + 128;
//        printf("%u bytes alloced = %.4X",bytes,i*2);
        return i*2;
        mx:;
        }
    printf("Not enough mem!: bytes=%u",bytes); beeper();
    return 0;
    }

void mem_free(char *addr)
    {
    UINT seg=FP_SEG(addr)/2;
    UCHR dat;
    if(addr == NULL) return;
//    printf("freeing %.4X",FP_SEG(addr));
    if(((dat=memtab[seg] & 0x7F) == 127) || dat == 0 || FP_OFF(addr) != 0)
        {
        beeper();
        printf("\a##dat=%i,OFF=%.4X##\a",dat,FP_OFF(addr));
        return;
        }
    while(memtab[seg] == dat)
        memtab[seg++] = 0;
    if(memtab[seg] == (dat | 128))
        memtab[seg] = 0; 
    }

char *mem_strnew(char *o, int tid)
    {
    char *n=mem_alloc(strlen(o)+1,tid);
    strcpy(n,o);
    return n;
    }

void mem_cleanup(int tid)
    {
    UINT i;
    ++tid;
    for(i=0;i<32768;i++)
        if((memtab[i] & 0x7F) == tid)
            memtab[i] = 0;
    }

unsigned mem_getpara(UCHR ofid)
    {
    unsigned num=0,i;
    for(i=0;i<32768;i++)
        if(i > 0 && i < 128)
            {
            if(memtab[i] & 0x7F == ofid)
                num++;
            }
        else
            if(memtab[i] == ofid)
                num++;
    return num;
    }

void *mem_dupobj(void *obj,unsigned size,int owner)
    {
    void *x=mem_malloc(size,owner);
    memcpy(x,obj,size);
    return x;
    }

#define mem_strdup(str,owner) (mem_dupobj((str),strlen((str))+1,(owner)))
