// Windowmanager-Interface (includes the ulsop-wm (/dev/ulsopwm, ID 133))
#define ULWM_MAXWIN 64

// char *ilasulwinlogo = "K  K    KKK  KKK      A A A A   A A A\nKC KC   K KC KCCC  L  A A A A A A AAA\nKC KC   KKKC KKK   L  A A A  AAA  A A\nKC KC   KCKC   KC  L  A A A  A A  A A\nKC KKK  KCKC KKKC  L  A A A\n C  CCC  C C  CCC     AAA AAAAAAAAAAA";
char *ilasulwinlogo = "K  K    KKK  KKK\nKC KC   K KC KCCC\nKC KC   KKKC KKK\nKC KC   KCKC   KC\nKC KKK  KCKC KKKC\n C  CCC  C C  CCC";
#define ilaslogo ilasulwinlogo

int hbheight, tbheight;

#define WF_POS 1
#define WF_SIZE 2
#define WF_WPRG 4
#define WF_FILL 8
#define WF_FULLSCREEN 16
#define WF_TITLE 32
#define WF_ICON_SPRITE 64
#define WF_ICON_DDB 128
#define WF_ICON_0815 192

// Flags for wm_paint
#define PF_WMBARS 1
#define PF_WNDBORDER 2
#define PF_WNDCONTENT 4

struct createwin
    {
    UINT owner;
    UINT flags;
    UINT x,y;
    UINT w,h;
    void *wprg;
    char *title;
    void *icon;
    UINT fill;
    };

void *wmcall=NULL;

wm_select(char *wmname)
    {
    int i=0;
    if(matchfirst(wmname,"/dev/")) wmname += 5;
    if(uldat)
        {
        printf("memfreeewmselect");
        mem_free((char *) uldat);
        uldat = NULL;
        }
    for(i=0;i<DRIVER_MAX;i++)
        if(drvlist[i].used && drvlist[i].dtyp == DTYP_WINDOWMANAGER && !strcmp(wmname,drvlist[i].dname))
            {
            if(i == 133)    // ulsopwm?
                {
                if((uldat = (struct ulwmdata *) malloc(sizeof(struct ulwmdata))) == NULL)
                    return ERR_OUTOFMEMORY;
                tbheight = 16;
                hbheight = 10;
                for(i=0;i<ULWM_MAXWIN;i++)
                    uldat->windat[i].used = 0;
                return 0;
                }
            return ERR_NOTIMPLEMENTED;
            }
    return ERR_FILENOTFOUND;
    }

void wm_setpixel(UINT wnd, UINT x,UINT y,UINT col)
    {
    if(!wnd) setpixel(x,y,col); else
    if(uldat)
        {
        y += hbheight;
        if(fgwin == wnd && y < (cury - tbheight) && x < curx)
            setpixel(x,y,col);
        }
    }

unsigned wm_getpixel(UINT wnd, UINT x, UINT y)
    {
    if(uldat)
        {
        y += hbheight;
        if(fgwin == wnd && y < (cury - tbheight) && x < curx)
            return getpixel(x,y);
        }
    }

void wm_set0815(UINT wnd, UINT x, UINT y, UINT *data)
    {
    if(!wnd) set0815(x,y,data); else
    if(uldat)
        {
        y += hbheight;
        if(fgwin == wnd && y < (cury - tbheight) && x < curx)
            {
            UINT yy;
            if((yy = y + data[1]) > cury)
                {
                data[1] -= yy - cury;
                set0815(x,y,data);
                data[1] = yy - y;
                }
            else
                set0815(x,y,data);
            }
        }
    }

void wm_get0815(UINT wnd, UINT x1, UINT y1, UINT x2, UINT y2, UINT *data)
    {
    if(uldat)
        {        
        y1 += hbheight;
        y2 += hbheight;
        get0815(x1,y1,x2,y2,data);
        }
    }

void wm_hline(UINT wnd, UINT x1,UINT y,UINT x2,UINT col)
    {
    if(!wnd) hline(x1,y,x2,col); else
    if(uldat)
        {
        y += hbheight;
        if(fgwin == wnd && y < (cury - tbheight) && x1 < curx)
            hline(x1,y,x2,col);
        }
    }

void wm_vline(UINT wnd, UINT y1,UINT x,UINT y2,UINT col)
    {
    if(!wnd) vline(y1,x,y2,col); else
    if(uldat)
        {
        y1 += hbheight;
        y2 += hbheight;
        if(fgwin == wnd && y1 < (cury - tbheight) && x < curx)
            {
            if(y2 >= (cury-tbheight)) y2 = (cury-tbheight)-1;
            vline(y1,x,y2,col);
            }
        }
    }
    
void wm_rect(UINT wnd, UINT x1, UINT y1, UINT x2, UINT y2, UINT col)
    {
    if(!wnd) rect(x1,y2,x2,y2,col); else
    if(uldat)
        {
        if(fgwin == wnd)
            if((y2+hbheight) >= (cury-tbheight))
                {
                wm_vline(wnd,y1,x1,y2,col);
                wm_vline(wnd,y2,x2,y2,col);
                wm_hline(wnd,x1,y1,x2,col);
                wm_hline(wnd,x1,y2,x2,col);
                }
            else
                rect(x1,y1+hbheight,x2,y2+hbheight,col);
        }
    }

void wm_rectf(UINT wnd, UINT x1, UINT y1, UINT x2, UINT y2, UINT col)
    {
    if(!wnd) rectf(x1,y1,x2,y2,col); else
    if(uldat)
        {
        y1 += hbheight;
        y2 += hbheight;
        if(fgwin == wnd && y1 < (cury-tbheight))
            {
            if(y2 >= (cury-tbheight)) y2 = (cury-tbheight) - 1;
            rectf(x1,y1,x2,y2,col);
            }
        }
    }

#define wm_fillclient(wnd,col) wm_rectf((wnd),0,0,curx-1,cury-1,(col))

void wm_drawsprite(UINT wnd, UINT x, UINT y, char *sprite)
    {
    if(!wnd) drawsprite(x,y,sprite); else
    if(uldat)
        {
        y += hbheight;
        if(fgwin == wnd && y < (cury-tbheight))
            drawsprite(x,y,sprite);    // TODO: Check and correct sprite-size
        }
    }

#define wm_textout wm_outtext
wm_outtext(UINT wnd, int x, int y, UINT fgc, UINT bgc, int fntid, char far *thetext)
    {
    if(!wnd) outtext(x,y,fgc,bgc,fntid,thetext); else
    if(uldat)
        {
        y += hbheight;
        if(fgwin == wnd && y < (cury-tbheight))
            return outtext(x,y,fgc,bgc,fntid,thetext);     // TODO: Check fontheight
        }
    }

void wm_drawddb(UINT wnd, UINT x, UINT y, char *ddb)
    {
    if(uldat)
        {
        y += hbheight;
        if(fgwin == wnd && y < (cury-tbheight))
            drawddb(x,y,ddb);       // TODO: Check (and correct) ddb-size
        }
    }

void wm_paint(UINT flgs, UINT wnd)
    {
    int i,x,y;
    if(!flgs) return;
    if(uldat)
        {
        if(flgs & PF_WMBARS)
            {
            printf("wm_paint");
                // Draw the titlebar
            rect(0,0,curx-1,hbheight-1,13);
            rectf(1,1,curx-2,hbheight-2,9);
            if(fgwin)
                {
                printf("textout");
                textout(11,1,12,0xFFF,0,uldat->windat[fgwin].title);
                printf("icon");
                if((uldat->windat[wnd].flgs & WF_ICON_SPRITE) == WF_ICON_SPRITE)
                    drawsprite(2,1, (char *) uldat->windat[wnd].icon);
                if((uldat->windat[wnd].flgs & WF_ICON_DDB) == WF_ICON_DDB)
                    drawddb(2,1,uldat->windat[wnd].icon);
                if((uldat->windat[wnd].flgs & WF_ICON_0815) == WF_ICON_0815)
                    set0815(2,1,uldat->windat[wnd].icon);
                printf("if fgwin done");
                }
            printf("ilaslogo");
            drawsprite(curx-20,2,ilasulwinlogo);

                // Draw the taskbar
            printf("taskbar");
            rectf(0,cury-tbheight,curx-1,cury-1,15);
            x = 0; y = cury-tbheight;
            for(i=0;i<ULWM_MAXWIN;i++)
                if(uldat->windat[i].used)
                    {
                    textout(x,y,0,0xFFF,0,uldat->windat[i].title);
                    if(x) x=0,y+=8; else x = curx/2;
                    }

            printf("bars OK");
            // TODO: Draw more stuff in the taskbar
            }
        if(flgs & PF_WNDCONTENT)
            {
            printf("sending paint");
            sendmessage(0,uldat->windat[wnd].owner,MSG_PAINT,wnd,0,0);
            printf("paint sent");
            }
        }
    printf("wm_paint: done");
    }

wm_create(struct createwin *windesc)
    {
    if(uldat)
        {
        int i;
        for(i=1;i<ULWM_MAXWIN;i++)
            if(!uldat->windat[i].used)
                {
                windesc->flags = windesc->flags & (WF_WPRG | WF_TITLE | WF_ICON_0815 | WF_FILL);
                windesc->x = 0;
                windesc->y = 0;
                windesc->w = curx;
                windesc->h = cury-tbheight-hbheight;
                uldat->windat[i].flgs = windesc->flags;
                if(windesc->flags & WF_TITLE) uldat->windat[i].title = mem_strdup(windesc->title,windesc->owner);
                if(windesc->flags & WF_ICON_0815) uldat->windat[i].icon = mem_strdup(windesc->icon,windesc->owner);
                uldat->windat[i].owner = windesc->owner;
                uldat->windat[i].wprg = windesc->wprg;
                uldat->windat[i].fill = windesc->fill;
                uldat->windat[i].used = 1;
                return i;
                }
        return ERR_OUTOFWNDS;
        }
    return ERR_NOTIMPLEMENTED;
    }

void wm_fgwindow(UINT wnd)
    {
    if(uldat)
        {
        fgwin = wnd;
        wm_paint(PF_WNDBORDER | PF_WMBARS | PF_WNDCONTENT,wnd);
        }
    }

void wm_delete(UINT wnd)
    {
    int i;
    printf("deleting wnd %i",wnd);
    if(uldat)
        {
        if(uldat->windat[wnd].flgs & WF_TITLE) { printf("freetitle"); mem_free(uldat->windat[wnd].title); }
        if(uldat->windat[wnd].flgs & WF_ICON_0815) { printf("freeicon"); mem_free(uldat->windat[wnd].icon); }
        uldat->windat[wnd].used = 0;
        if(fgwin == wnd)
            {
            for(i=wnd-1;i>=0;i--)
                if(uldat->windat[i].used)
                    {
                    newfgwin:
                    printf("new fgwin=%i",i);
                    wm_fgwindow(i);
                    printf("is in fg");
                    return;
                    }
            for(i=wnd+1;i<ULWM_MAXWIN;i++)
                if(uldat->windat[i].used)
                    goto newfgwin;
            printf("last wnd killed, no fgwin");
            clearscr(0);
//            wm_paint(PF_WMBARS,0);
            fgwin = 0;
            }

        }
    }

wm_cleanup(UINT proc)
    {
    int i;
    if(uldat)
        for(i=1;i<ULWM_MAXWIN;i++)
            if(uldat->windat[i].used && uldat->windat[i].owner == proc)
                wm_delete(i);
    }

wm_mouse(UINT x, UINT y, UINT btn)
    {
    static UINT ox,oy,obtn,iobtn;
    int xx,yy,i;
    if(uldat)
        {
        if(!btn && iobtn)
            {
            if(y <= hbheight)
                {           
                if(x<(curx-8))
                    sendmessage(0,uldat->windat[fgwin].owner,MSG_CLOSEWND,fgwin,1,0);
                }
            else if(y >= (cury-tbheight))
                {       // TB-Clicks (TODO: Handle them)
                xx = 0; yy = cury-tbheight;
                for(i=0;i<ULWM_MAXWIN;i++)
                    if(uldat->windat[i].used)
                        {
                        if(y >= yy && y <= (yy+7))
                            if(x >= xx && x <= (xx+textwidth(0,uldat->windat[i].title)))
                                {
                                fgwin = i;
                                wm_paint(7,fgwin);
                                iobtn=btn;
                                return 0;
                                }
                        if(xx) xx=0,yy+=8; else xx = curx/2;
                        }
                }
            }
        if((y > hbheight) && (y < (cury-tbheight)))
            {
            y-=hbheight;
            if((x != ox) || (y != oy))
                ox=x,oy=y,sendmessage(0,uldat->windat[fgwin].owner,MSG_MOUSEMOVE,fgwin,x,y);
            if(obtn != btn)
                sendmessage(0,uldat->windat[fgwin].owner,MSG_MOUSEBUTTON,fgwin,btn,obtn),obtn=btn;
            } // else beeper();
        iobtn=btn;
        }
    }

wm_keyb(UINT action, UINT code)
    {
    if(action == KB_KEYDOWN)
        sendmessage(0,uldat->windat[fgwin].owner,MSG_KEYDOWN,fgwin,code,action);
    else if(action == KB_KEYUP)
        sendmessage(0,uldat->windat[fgwin].owner,MSG_KEYUP,fgwin,code,action);
    else if(action == KB_KEYPRESS)
        sendmessage(0,uldat->windat[fgwin].owner,MSG_KEYPRESS,fgwin,code,action);
    }

void dispatchmessage(UINT from, UINT to, UINT msg, UINT a, UINT b, UINT c)
    {
    if(msg < MSG_PAINT)
        {   // Process messages
        // TODO: Handle them
        }
    else
        {   // Window messages
//        printf("Dispatch: from %i, to %1, msg %i, a=%i, b=%i, c=%i\n",from,to,msg,a,b,c);
        gui_wmintercept(msg,a,b,c);
        if(uldat)
            {
            if(uldat->windat[a].flgs & WF_WPRG)
                callmeback(uldat->windat[a].wprg);
            }
        }
    }

getwndowner(UINT wnd)
    {
    if(uldat)
        return uldat->windat[wnd].owner;
    }

wm_dib_draw_dib(int wnd, int x, int y, int hndl)
    {
    unsigned i,j;
    int ii;
    void *ddb;
    dib_geometry(hndl,&i,&j);
    if((ddb = mem_malloc(sizeofddb(i,j),finddib(hndl)->owner)) != NULL)
        if((ii = dib_to_ddb(hndl,ddb,0,0,i-1,j-1)) < 0)
            {
            mem_free(ddb);
            return ii; 
            }
    wm_drawddb(wnd,x,y,ddb);
    mem_free(ddb);
    }

mkulwin(int hndl, char *str)
    {
    int h;
    struct createwin w;
    w.owner = hndl;
    w.flags = WF_TITLE;
    w.title = str;
    sendmessage(0,hndl,MSG_PAINT,(h = wm_create(&w)),0,0);
    wm_fgwindow(h);
    return h;
    }
